/*
 * =====================================================================================
 *
 *       Filename:  ToolBase.h
 *
 *    Description:  
 *
 *        Version:  1.0
 *        Created:  05/16/2008 08:16:33 AM
 *       Revision:  11/20/2008 by feeldead`
 *       Compiler:  g++
 *
 *         Author:  Jianxing Feng (feeldead), feeldead@gmail.com
 *        Company:  THU
 *
 * =====================================================================================
 */

#ifndef ToolBase_h
#define ToolBase_h
#include <vector>
#include <string>

using namespace std;

/*
 * =====================================================================================
 *        Class:  ToolBase
 *  Description:  Provides basic interfaces of small tools
 * =====================================================================================
 */
class ToolBase
{
	public:
		ToolBase ();                             /* constructor */
		virtual ~ToolBase ();                             /* constructor */
		virtual int Main(int argc, char* argv[], int startArg) = 0;
		virtual void Help() = 0;
		virtual void ArgMissing(string arg);

		void ParseDelimits(char* args, vector<char>& delimits, char escape);
		void ParseFields(char* args, vector<int>& fields);

	protected:

}; /* -----  end of class  ToolBase  ----- */

#endif
